/********************************************************************************/
/* Sample for resetprg.c														*/
/********************************************************************************/
#include <machine.h>								// Use Embedded Function
#pragma stacksize si=0x200							// Interrupt Stack is 512Byte

#ifdef __RON										// -round=nearest
	#ifdef __DOFF									// -denormalize=off
		#define FPSW_init 0x00000100
	#else											// -denormalize=on
		#define FPSW_init 0x00000000
	#endif
#else												// -round=zero
	#ifdef __DOFF									// -denormalize=off
		#define FPSW_init 0x00000101
	#else											// -denormalize=on
		#define FPSW_init 0x00000001
	#endif
#endif

void HardwareSetup(void);
void _INITSCT(void);
void main(void);

#pragma section P PResetPRG							// Section Name is PResetPRG
#pragma entry PowerON_Reset							// Entry Function
void PowerON_Reset(void)
{ 
#if __RENESAS_VERSION__ < 0x01010000
		set_intb((unsigned long)__sectop("C$VECT"));// Initialize of INTB
#else
		set_intb(__sectop("C$VECT"));				// Initialize of INTB
#endif
	set_fpsw(FPSW_init);							// Initialize of FPSW
	HardwareSetup( );								// Setup of H/W
	_INITSCT( );									// Initialize of Static Variable
	main( );										// Execute main Function
}