/***********************************************************************/
/*                                                                     */
/*  FILE        :resetprg.c                                            */
/*  DATE        :Fri, Apr 01, 2011                                     */
/*  DESCRIPTION :Reset Program                                         */
/*  CPU TYPE    :SH72620                                               */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.18).    */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/***********************************************************************/
/*********************************************************************
*
* Device     : SH2A-FPU
*
* File Name  : resetprg.c
*
* Abstract   : Initialize for C/C++ language.
*
* History    : 1.00  (2008-01-24)
*              1.10  (2010-06-22)
*
* NOTE       : THIS IS A TYPICAL EXAMPLE.
*
* Copyright (C) 2008 (2010) Renesas Electronics Corporation and
* Renesas Solutions Corp. All rights reserved.
*
*********************************************************************/

#include	<machine.h>
#include	<_h_c_lib.h>
//#include	<stddef.h>					// Remove the comment when you use errno
//#include 	<stdlib.h>					// Remove the comment when you use rand()
#include	"typedefine.h"
#include	"stacksct.h"

//#define SR_Init    0x000000F0
#define SR_Init    0x000000E0
#ifdef _FPD	// when -fpu=double is specified
#define FPSCR_Init 0x000C0001
#else
#define FPSCR_Init 0x00040001
#endif
#ifdef _RON	// when -round=nearest is specified
#define FPSCR_RM 0xfffffffc
#else
#define FPSCR_RM 0xfffffffd
#endif
#define INT_OFFSET 0x10

extern _UINT INT_Vectors;

#ifdef __cplusplus
extern "C" {
#endif
void PowerON_Reset_PC(void);
void Manual_Reset_PC(void);
void main(void);
#ifdef __cplusplus
}
#endif

#pragma section ResetPRG

#pragma entry PowerON_Reset_PC

void PowerON_Reset_PC(void)
{
	set_vbr((void *)((_UBYTE *)&INT_Vectors - INT_OFFSET));

	//set_fpscr(FPSCR_Init & FPSCR_RM);
	set_fpscr(FPSCR_Init);

	HardwareSetup();				// Use Hardware Setup

	_INITSCT();

	set_cr(SR_Init);

	main();

	while(1);
}

//#pragma entry Manual_Reset_PC		// Remove the comment when you use Manual Reset
void Manual_Reset_PC(void)	
{
}
