// =========================================== 
// MPC104-DAC12 PC/104-8bit I/O
// =========================================== 

#include <math.h>							// SIN ŕKv
#include "PC104_DAC8.h"

//#define DAC12BASE	0x28100000				// FRK-SH2A + LFCQ1 PC/104 8bit I/OGA 擪AhX(Œ)
//#define DAC12BASE	0x05100000				// FRK-RX62N + LFCQ1 PC/104 8bit I/OGA 擪AhX(Œ)
#define DAC12OFFS	0x7c0					// MPC104-DAC12 ItZbg o׎AhX(SW1 SW4 ŕύX\)
//#define DAC12ADRS	(volatile unsigned char *)(DAC12BASE + DAC12OFFS)
//#define dac12_out()	*(DAC12ADRS + 0x10)	= 0;	// DACo͍XV

static volatile unsigned char *DAC12ADRS;	// MPC104-DAC12 ItZbg o׎AhX(SW1 SW4 ŕύX\)

// ===========================================
// DACo͍XV
void dac12_out(void)
{
	*(DAC12ADRS + 0x10) = 0;
}

// ===========================================
// DACw`lɃf[^ݒ
// b`܂Ńf[^͏o͂Ȃ
void dac12_set(int ch,						// DAC`l(0`7)
			   unsigned short dat)			// o̓f[^(0`0xfff)
{
	ch <<= 1;								// `l
	*(DAC12ADRS + ch) = (unsigned char)(dat & 0x00ff);	// 8bit
	*(DAC12ADRS + ch + 1)	= (unsigned char)((dat >> 8) & 0x000f);	// 4rbg
}

// ===========================================
// DAC
// n[hZbgȂ̂ŋɗ͑
void dac12_init(
	unsigned long ba)						// x[XAhX
{
	int c;
	
	DAC12ADRS = (unsigned char *)(ba + DAC12OFFS);	// x[XAhXύX\Ƃ
	
	for(c = 0; c <= 7; c++)
	{
		dac12_set(c, 0);					// o̓f[^Zbg
	}
	dac12_out();							// f[^b`o
}

// ===========================================
// DACeXgŃTCg`o
// e`l45xÂʑ炵Ă܂
#ifndef PI
#define PI 3.141592654						// ~
#endif
#ifndef DEG_RAD
#define DEG_RAD(Q) ((Q)*PI/180)				// x>WAϊ
#endif
#ifndef RAD_DEG
#define RAD_DEG(Q) ((Q)/PI*180)				// WA>xϊ
#endif
void dac12_tsk(void)
{	
	static int seq = 0;						// V[PX
	static int sind[] = {0, 45, 90, 135, 180, 225, 270, 315};	// px
	static unsigned short sin_tbl[360];		// TCge[u
	int c;									// JE^
	
	switch(seq)
	{
	case 0:									// TCge[u
		for(c = 0; c <= 359; c++)
		{
			sin_tbl[c] = (unsigned short)((sin(DEG_RAD(c)) + 1) * 0x7ff);
		}
		seq++;
		break;
	case 1:
		for(c = 0; c <= 7; c++)
		{
			dac12_set(c, sin_tbl[sind[c]]);	// o̓f[^Zbg
			if(sind[c] < 359)
			{
				sind[c]++;
			}
			else
			{
				sind[c] = 0;
			}
		}
		dac12_out();						// f[^b`o
		break;
	}
}
